"use strict";
/**
 * @module botbuilder
 */
/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallerIdConstants = void 0;
/**
 * Constants used to populate the Activity.callerId property.
 */
class CallerIdConstants {
}
exports.CallerIdConstants = CallerIdConstants;
/**
 * The caller ID for any Bot Framework channel.
 */
CallerIdConstants.PublicAzureChannel = 'urn:botframework:azure';
/**
 * The caller ID for any Bot Framework US Government cloud channel.
 */
CallerIdConstants.USGovChannel = 'urn:botframework:azureusgov';
/**
 * The caller ID prefix when a bot initiates a request to another bot.
 *
 * @remarks
 * This prefix will be followed by the Azure Active Directory App ID of the bot that initiated the call.
 */
CallerIdConstants.BotToBotPrefix = 'urn:botframework:aadappid:';
//# sourceMappingURL=callerIdConstants.js.map